unit nibblUni;

INTERFACE
uses
  nibbsnak, nibbljoy, nibbmaus;

const
  maxSpieler = 5;
  levelDatei = 'level4';
  nameLength = 9;
  configFile = 'nibbles.ini';

type
  snakeData = ^sdInhalt;
  sdInhalt = record
               name: string[nameLength];
               left, right, up, down, color: byte;
               vor, zurueck: snakeData;
               active: boolean;
             end;
var
  schlange: array[1..maxSpieler] of pSchlange;
  schlangenDaten: snakeData;
  sprache: string;
  bFarb, wFarb, verzoegerung, spieler, maxPunkte: byte;

  procedure neuSchlange(zeile: string);
  function loescheSchlange(var zeile: string): boolean; {1. Schlange
    loeschen, zeile = (name + links + ... + farbe)}
  procedure fehlerMeldung;
  procedure erfolgMeldung;
  procedure spielerHinzufuegen;
  procedure optionen;

IMPLEMENTATION
uses
  nibbserv, nibbtext, nibbmenu, crt;

procedure fehlerMeldung;
begin
  gotoxy(72, wherey);
  textcolor(lightred);
  writeln('failed');
  textcolor(lightgray);
end;

procedure erfolgMeldung;
begin
  gotoxy(72, wherey);
  textcolor(green);
  writeln(' done');
  textcolor(lightgray);
end;

function loescheSchlange(var zeile: string): boolean;
var
  temp: snakeData;
begin
  zeile:= '';
  if schlangenDaten <> nil then
  begin
    with schlangenDaten^ do
      zeile:= name + ' ' + int2str(left) + ' ' + int2str(right) + ' '
               + int2str(up) + ' ' + int2str(down) + ' ' + int2str(color);
    temp:= schlangenDaten;
    schlangenDaten:= schlangenDaten^.vor;
    schlangenDaten^.zurueck:= nil;
    dispose(temp);
    loescheSchlange:= true;
  end
  else loescheSchlange:= false;
end;

procedure neuSchlange(zeile: string);
var
  neu, lauf: snakeData;
  ende: boolean;
  temp: string;
begin
  new(neu);
  neu^.name:='';
  with neu^ do
  begin
    active:= false;
    temp:= zeile;
    color:= zeilenEndWert(temp);
    down:= zeilenEndWert(temp);
    up:= zeilenEndWert(temp);
    right:= zeilenEndWert(temp);
    left:= zeilenEndWert(temp);
    name:= temp;
  end;
  ende:= false;
  lauf:= schlangenDaten;
  if schlangenDaten = nil then
  begin
    schlangenDaten:= neu;
    schlangenDaten^.vor:= nil;
    schlangenDaten^.zurueck:= nil;
  end
  else
  repeat
    if gr(neu^.name) < gr(lauf^.name) then
    begin                   {vor lauf anfgen}
      neu^.vor:= lauf;
      neu^.zurueck:= lauf^.zurueck;
      if lauf^.zurueck = nil then schlangenDaten:=neu
                             else lauf^.zurueck^.vor:= neu;
      lauf^.zurueck:= neu;
      ende:= true;
    end
    else
    if lauf^.vor = nil then
    begin                  {am Ende der List anfgen}
      lauf^.vor:= neu;
      neu^.vor:= nil;
      neu^.zurueck:= lauf;
      ende:= true;
    end
    else lauf:= lauf^.vor;
  until ende;
end;

function findeSchlangenNummer(name: string): byte;
var
  i, wert: byte;
begin
  i:= 1;
  for i:= 1 to spieler do
    if schlange[i]^.name = name then wert:= i;
  findeSchlangenNummer:= wert;
end;

procedure spielerHinzufuegen;
const
  menuBgColor = cyan;
  menuFgColor = black;
var
  lauf, position, bildanf, bildend: snakeData;
  ch: char;
  i, nummer: byte;
const
  listenLaenge = 13;
  procedure menuFarben;
  begin
    textcolor( menuFgColor );
    textbackground( menuBgColor );
  end;
  function abstand(anfang: snakeData; groesse: byte): pointer;
  var
    i: word;
  begin
    lauf:= anfang;
    i:= 1;
    while ((i < groesse) and (lauf^.vor <> nil)) do
    begin
      inc(i);
      lauf:= lauf^.vor;
    end;
    abstand:= lauf;
  end;
  procedure spielerLoeschen(element: snakeData);
  begin
    if schlangenDaten = element then   {Sonderfall erstes Element}
    begin
      schlangenDaten:= schlangenDaten^.vor;
      if schlangenDaten <> nil then schlangenDaten^.zurueck:= nil;
    end
    else
    begin
      if element^.zurueck <> nil then element^.zurueck^.vor:= element^.vor;
      if element^.vor <> nil then element^.vor^.zurueck:= element^.zurueck;
    end;
    dispose(element);
  end;
  procedure schlangenZeile(zSchlange: snakeData; tFarbe, hFarbe: byte);
  var
    k: byte;
  begin
    if zSchlange^.active then textcolor(lightgreen)
                         else textcolor(tFarbe);
    textbackground(hFarbe);
    with zSchlange^ do
    begin
      write('  ', name);
      for k:= wherex to (nameLength + 28) do write(' ');
      if ((left = 75) and (right = 77) and (up = 72) and (down = 80)) then
        write(char(27), ' ', char(26), ' ',char(24), ' ', char(25)) else
      if left = nibbMaus.mausLinks then write(' mouse') else
      begin
        if left = nibbljoy.j1l then write('joy1') else
        if left = nibbljoy.j2l then write('joy2') else
        begin
          write( char(left), ',' + char(right) + ',');
          if left <> up then write( char(up) + ',' + char(down) );
        end;
        if left = up then write(' rel');
      end;
      for k:= wherex to (nameLength + 37) do write(' ');
      write(color, ' ');
      textcolor(color);
      for k:= 1 to 5 do write(char(220));
      write('  ');
    end;
  end;
  procedure hinzufuegenFenster;
  begin
    textcolor( Yellow );
    textbackground( menuBgColor );
    window(23, 5, 57, (8 + listenLaenge));
    clrscr;
    window(1, 1, 80, 25);
    gotoxy(25, 6);
    write('  Name       Control  Color');
  end;
  function neuerName: string;
  var
    sName: string[nameLength];
    nXpos, nYpos: byte;
    function pruefeName: boolean;
    var
      temp: snakeData;
      vorhanden: boolean;
    begin
      vorhanden:= false;
      temp:= schlangenDaten;
      while temp <> nil do
      begin
        if temp^.name = sName then vorhanden:= true;
        temp:= temp^.vor;
      end;
      if vorhanden then hilfText(nibbtext.nameVorhandenTxt, true);
      pruefeName:= not(vorhanden);
    end;
  begin
    nXpos:= whereX;
    nYpos:= whereY;
    hilfText(nibbText.nameEingebenTxt, false);
    repeat
      menuFarben;
      gotoxy(nXpos, nYpos);
      write('           ');
      gotoxy(nXpos, nYpos);
      readln(sName);
    until pruefeName;
    neuerName:= sName;
  end;
  procedure neueSteuerung(var nLinks, nRechts, nHoch, nRunter: byte);
  var
    b: char;
    sJoystick: byte;
    relativeSteuerung: boolean;
    procedure tasteHolen(var x: byte; hText: string);
    begin
      hilfText(nibbText.tastenFestlegenTxt + ': &' + hText, true);
      b:= readkey;
      if ord(b) = 0 then b:= readkey;
      x:= ord(b);
      menuFarben;
      write(b + ' ');
    end;
    function holRelSteuer: boolean;
    begin
      hilfText(nibbText.relativeSteuerungTxt, false);
      repeat
        b:= readkey;
      until (b = '1') or (b = '2');
      holRelSteuer:= (b = '2');
    end;
  begin
    gotoxy(38, 7);
    menuFarben;
    write('       ');
    hilfText(nibbText.joystickBenutzenTxt, false);
    write(' ');
    repeat
      b:= readkey;
      sJoystick:= str2int(b);
    until (sJoystick > 0) and (sJoystick < 5);
    if sJoystick <> 2 then relativeSteuerung:= holRelSteuer;
    gotoxy(38, 7);
    menuFarben;
    case sJoystick of
      1: begin
           tasteHolen(nLinks, nibbtext.linksTxt);
           tasteHolen(nRechts, nibbtext.rechtsTxt);
           if relativeSteuerung then write('rel') else
           begin
             tasteHolen(nHoch, nibbtext.hochTxt);
             tasteHolen(nRunter, nibbtext.runterTxt);
           end;
         end;
      2: begin
           write(' mouse');
           nLinks:= mausLinks;
           nRechts:= mausRechts;
         end;
      3: begin
           write('  joy1');
           nLinks:= nibbljoy.j1l;
           nRechts:= nibbljoy.j1r;
           if not(relativeSteuerung) then
           begin
             nHoch:= nibbljoy.j1o;
             nRunter:= nibbljoy.j1u;
           end;
         end;
      4: begin
           write('  joy2');
           nLinks:= nibbljoy.j2l;
           nRechts:= nibbljoy.j2r;
           if not(relativeSteuerung) then
           begin
             nHoch:= nibbljoy.j2o;
             nRunter:= nibbljoy.j2u;
           end;
         end;
    end;
    if relativeSteuerung then
    begin
      nHoch:= nLinks;
      nRunter:= nRechts;
    end;
  end;
  procedure neueFarbe(var nFarbe: byte);
  var
    j: byte;
    b: char;
  begin
    hilfText(nibbText.farbeWaehlenTxt, true);
    repeat
      gotoxy((nameLength + 38), wherey);
      menuFarben;
      write(nFarbe, ' ');
      textcolor(nFarbe);
      for j:= 1 to 5 do write(char(220));
      b:= readkey;
      if ord(b) = 0 then b:= readkey;
      if (((b = 'K') or (b = 'H')) and (nFarbe > 0)) then dec(nFarbe) else
        if (((b = 'M') or (b = 'P')) and (nFarbe < 7)) then inc(nFarbe);
    until b = char(13);
  end;
  procedure schlangeErzeugen;
  var
    sName: string[nameLength];
    sLinks, sRechts, sHoch, sRunter, sFarbe: byte;
  begin
    csrOn;
    hinzufuegenFenster;
    gotoxy(26, 7);
    sName:= neuerName;
    neueSteuerung(sLinks, sRechts, sHoch, sRunter);
    sFarbe:= 0;
    neueFarbe(sFarbe);
    neuSchlange(sName + ' ' + int2str(sLinks) + ' ' + int2str(sRechts) + ' '
                  + int2str(sHoch) + ' ' + int2str(sRunter) + ' '
                  + int2str(sFarbe));
    csrOff;
  end;
  procedure schlangeAendern;
  var
    b: char;
    geaendert: boolean;
  begin
    geaendert:= true;
    hinzufuegenFenster;
    gotoxy(24, 7);
    schlangenZeile(position, menuFgColor, menuBgColor);
    hilfText(nibbText.schlangeAendernTxt, false);
    csrOn;
    b:= readkey;
    gotoxy(26, 7);
    if ord(b) = 0 then b:= readkey;
    case str2int(b) of
      1: position^.name:= neuerName;
      2: neueSteuerung(position^.left, position^.right, position^.up, position^.down);
      3: neueFarbe(position^.color);
      else geaendert:= false;
    end;
    hilfText(nibbText.hinzufuegenTxt, true);
    csrOff;
  end;
  procedure naechsteWaehlen;
  begin
    if position^.vor <> nil then
    begin
      if position = bildend then
      begin
        bildanf:= bildanf^.vor;
        bildend:= bildend^.vor;
      end;
      position:= position^.vor;
    end;
  end;
  procedure vorherigeWaehlen;
  begin
    if (position^.zurueck <> nil) then
    begin
      if position = bildanf then
      begin
        bildanf:= bildanf^.zurueck;
        bildend:= bildend^.zurueck;
      end;
      position:= position^.zurueck;
    end;
  end;
  procedure pos1key;
  begin
    while position^.zurueck <> nil do vorherigeWaehlen;
  end;
  procedure upDownChar( unten: boolean );
  begin
    textcolor(red + blink);
    textbackground( menuBgColor );
    if unten then
    begin
      gotoxy(55, (8 + listenLaenge - 2));
      write(char(31)); {}
    end
    else
    begin
      gotoxy(55, (8 - 1));
      write(char(30)); {}
    end;
  end;
begin {spielerHinzufuegen}
  HilfText(nibbtext.hinzufuegenTxt, false);
  hinzufuegenFenster;
  position:= schlangenDaten;
  bildanf:= schlangenDaten;
  bildend:= abstand(bildanf, listenLaenge);
  repeat
    i:= 0;
    lauf:= bildanf;
    while ( (lauf <> nil) and (lauf <> bildend^.vor) ) do {Liste ausgeben}
    begin
      inc(i);
      gotoxy(24, (6 + i));
      if lauf = position then schlangenZeile(lauf, white, green)
                         else schlangenZeile(lauf, menuFgColor, menuBgColor);
      lauf:= lauf^.vor;
    end;
    if bildanf^.zurueck <> nil then upDownChar( FALSE );
    if bildend^.vor <> nil then upDownChar( TRUE );
    menuFarben;
    gotoxy(24, (7 + i));
    write('                                ');
    gotoxy(1, (7 + i));
    ch:= readkey;
    if ord(ch) = 0 then ch:= readkey;
    hilfText(nibbtext.hinzufuegenTxt, true);
    if ch = 'R' then
    begin                             {Spieler hinzufgen}
      schlangeErzeugen;
      position:= schlangenDaten;
      bildAnf:= schlangenDaten;
      bildEnd:= abstand(schlangenDaten, listenLaenge);
      hilfText(nibbtext.hinzugefuegtTxt, true);
    end
    else
    if schlangenDaten <> nil then
    case ch of
      'H': vorherigeWaehlen; {up}
      'P': naechsteWaehlen; {down}
      'G': pos1key;
      'O': while position^.vor <> nil do naechsteWaehlen; {end-key}
      ' ': if position^.active then hilfText(nibbText.nichtAendernTxt, true)
             else schlangeAendern;
      char(13): begin                        {Ins Spiel oder raus}
                  if position^.active then
                  begin
                    position^.active:= false;
                    nummer:= findeSchlangenNummer(position^.name);
                    dispose(schlange[nummer]);
                    schlange[nummer]:= nil; {falls nummer = spieler}
                    schlange[nummer]:= schlange[spieler];
                    schlange[spieler]:= nil;
                    dec(spieler);
                    schlange[nummer]^.nummer:= nummer;
                  end
                  else
                  if spieler < maxSpieler then
                  begin
                    inc(spieler);
                    new(schlange[spieler]);
                    with position^do
                    begin
                      schlange[spieler]^.init(name, spieler, color, left,
                        right, up, down);
                      active:= true;
                    end;
                  end
                  else hilfText(nibbText.zuVieleSpielerTxt, true);
                end;
      'S': if position^.active then hilfText(nibbText.nichtAendernTxt, true)
           else
           begin                             {Loeschen}
             lauf:= position;                {temp-pointer, wird gelscht}
             if position^.zurueck = nil then {Entweder Anfang...}
             begin
               position:= position^.vor;
               bildanf:= bildanf^.vor;
               if bildend^.vor <> nil then bildend:= bildend^.vor;
             end
             else                            {...oder Ende...}
             if position^.vor = nil then
             begin
               position:= position^.zurueck;
               if bildanf^.zurueck <> nil then bildanf:= bildanf^.zurueck;
               bildend:= bildend^.zurueck;
             end
             else                            {...oder "Normal"}
             if bildend^.vor <> nil then
             begin
               if bildanf = position then bildanf:= bildanf^.vor;
               bildend:= bildend^.vor;
               position:= position^.vor;
             end
             else
             begin
               position:= position^.vor;
               if bildanf^.zurueck <> nil then bildanf:= bildanf^.zurueck;
             end;
             spielerLoeschen(lauf);
           end;
      else
      begin
        lauf:= position;
        repeat
          if position^.vor = nil then pos1Key else naechsteWaehlen;
        until (upcase(ch) = upcase(position^.name[1])) or (position = lauf);
      end;
    end; {von case}
  until ord(ch) = 27;
  textbackground( menuBgColor );
  window(23, 5, 57, (8 + listenLaenge));
  clrscr;
  window(1, 1, 80, 25);
end; {spielerHinzufuegen}

procedure optionen;
var
  wahl, x, altx: byte;
  menutext: string[82];
  ch: char;
  z: string[3];
  procedure holFarbe(var f: byte; von, bis: byte);
  begin
    altx:= wherex;
    repeat
      gotoxy(altx, wherey);
      textcolor(black);
      case f of
        88: write(' ' + txtLaenge(nibbText.zufallTxt, 9));
        99: write(' ' + txtLaenge(nibbText.standardTxt, 9));
        else
        begin
          write(f:3);
          textcolor(f);
          write(' ');
        end;
      end;
      ch:= readkey;
      if ord(ch) = 0 then ch:= readkey;
      case ch of
        'K', 'H': if ((f > von) and (f <= bis)) then dec(f) else
                    if f = 88 then f:= 99 else
                      if f = von then f:= 88;
        'M', 'P': if ((f >= von) and (f < bis)) then inc(f) else
                    if f = 99 then f:= 88 else
                      if f = 88 then f:= von;
      end;
    until ord(ch) = 13;
  end;

begin
  ch:= ' ';
  wahl:= 1;
  menuText:= '';
  nibbmenu.initMenu(1, hauptmenuTxt, joyTxt, geschwindTxt, bodenFarbTxt,
                       wandFarbTxt, siegPunkteTxt);
  repeat
    menu(wahl, brown, menuText);
    csrOn;
    menuText:= '';
    case wahl of
      2: repeat
           hilfText(nibbtext.joy1joy2txt, false);
           ch:= readkey;
           if ord(ch) = 0 then ch:= readkey;
           hilfText(nibbtext.joyProblemeTxt, false);
           window(20, 6, 60, 20);
           csrOff;
           case ch of
             '1': nibbljoy.calibrate(1);
             '2': nibbljoy.calibrate(2);
           end;
           csrOn;
           window(1, 1, 80, 25)
         until ord(ch) = 27;
      3: begin
           x:= verzoegerung;
           hilfText(nibbText.holGeschwTxt, false);
           altx:= wherex;
           repeat
             gotoxy(altx, wherey);
             write(x:2);
             ch:= readkey;
             if ord(ch) = 0 then ch:= readkey;
             case ch of
               '0'..'9': x:= str2int(ch);
               'K', 'H': if x > 0 then dec(x);
               'M', 'P': if x < 9 then inc(x);
             end;
           until ord(ch) = 13;
           verzoegerung:= x;
           if verzoegerung = 0 then menuText:= nibbText.geschw0Txt;
         end;
      4: begin
           hilfText(nibbText.holBFarbTxt, false);
           holFarbe(bFarb, 8, 15);
         end;
      5: begin
           hilfText(nibbText.holWFarbTxt, false);
           holFarbe(wFarb, 0, 7);
         end;
      6: repeat
           hilfText(nibbText.holSiegPunkteTxt + ' ', false);
           x := wherex;
           window( 1, 25, 80, 25 );
           gotoxy( x, wherey );
           readln( z );
           maxPunkte := str2int( z );
           window( 1, 1, 80, 25 );
         until ( maxPunkte > 1) and ( maxPunkte < 101);
    end;
    csrOff;
  until wahl = menuEndNummer;
end;

end.