unit nibbRule;

INTERFACE

  function holWachs(nummer, schlangeNr: byte): byte;
  procedure gibGesammelte(schlangeNr: byte);
  procedure initZiel;
  function spielEnde( imSpiel: byte ): boolean;
  procedure bilanz;

IMPLEMENTATION
uses
  nibblevl, crt, nibbluni, nibbserv;
var
  rote, blaue: array[1..9] of byte; { enthlt Nummer der besitzenden Schlange }
  rTop, bTop, endGrund: byte;

procedure bilanz;
const
  fgFarbe = LIGHTGRAY;
  hgFarbe = RED;
var
  i, j, getoetet: byte;
  spielEnde: boolean;

  procedure warteSchleife;
  begin
    delay( 1000 );
    write(^j, '  ' + nibbText.knopfDrueckenTxt);
    while keypressed do readkey;
    nibbserv.csrOn;
    readkey;
    nibbserv.csrOff;
  end;

  procedure siegerEhrung;
  var
    k, max, merker: byte;
  begin
    clrscr;
    max := 0;
    for k := 1 to nibbluni.spieler do
    begin
      if schlange[k]^.punkte > max then merker := k;
      schlange[k]^.punkte := 0;
    end;
    textcolor( white );
    writeln( ^j, nibbText.superTxt);
    write( ^j, ' ' );
    textbackground( schlange[ merker ]^.farbe );
    write( schlange[ merker ]^.name );
    textbackground( hgFarbe );
    textcolor( fgFarbe );
    writeln( ' ' + nibbText.mehrAlsTxt + ' ', (nibbluni.maxPunkte - 1),
             ' ' + nibbText.punkteTxt + '!' );
    writeln( ^j, ' ' + nibbText.endGameTxt );
    warteSchleife;
  end;

begin
  spielEnde := FALSE;
  textbackground( hgFarbe );
  window( 6, 6, 74, ( 13 + nibbluni.spieler ) );
  clrscr;
  textcolor( WHITE );
  writeln( ^j,  nibbtext.endTitelTxt);
  textcolor( fgFarbe );
  writeln( ^j, ' ' + nibbtext.endGrundTxt[endGrund] );
  writeln;
  for i := 1 to nibbluni.spieler do
  begin
    for j := 0 to nibbluni.namelength - length( schlange[i]^.name ) do
      write( ' ' );
    textcolor( white );
    textbackground( schlange[i]^.farbe );
    write( schlange[i]^.name );
    textcolor( fgFarbe );
    textbackground( hgFarbe );
    write( ' ' );
    getoetet := 0;
    for j := 1 to nibbluni.spieler do
    if ( j <> i ) and ( schlange[j]^.todesursache = i ) then inc( getoetet );
    inc( schlange[i]^.punkte, getoetet );
    if schlange[i]^.lebt then
    begin
      write( nibbtext.ueberlebteTxt + ' (+2)' );
      inc( nibbluni.schlange[i]^.punkte, 2 );
    end
    else
      if schlange[i]^.todesursache = i then
      begin
        write( nibbtext.selbstmordTxt + ' (-1)');
        if schlange[i]^.punkte > 0 then dec( schlange[i]^.punkte );
      end
      else
      if schlange[i]^.todesursache = nibbLevl.mauerFeld then
      begin
        write( nibbtext.wandTxt + ' (-1)');
        if schlange[i]^.punkte > 0 then dec( schlange[i]^.punkte );
      end
      else
      begin
        write( nibbText.todesUrsacheTxt + ' ' );
        textcolor( white );
        textbackground( schlange[ schlange[i]^.todesursache ]^.farbe );
        write( schlange[ schlange[i]^.todesursache ]^.name );
        textcolor( fgFarbe );
        textbackground( hgFarbe );
      end;
    if getoetet > 0 then
    begin
      write( ' ' + nibbText.erledigteTxt + ' ', getoetet );
      write( ' (+', getoetet, ')' );
    end;
    gotoxy( 64, wherey );
    writeln( char(26) + ' ' + int2str( schlange[i]^.punkte ): 5 ); {16, 26, 175}
    if schlange[i]^.punkte >= nibbluni.maxPunkte then spielEnde := TRUE;
  end;
  warteSchleife;
  if spielEnde then siegerehrung;
  clrscr;
end;

function alleGesammelt: boolean;
var
  i: byte;
  merker: boolean;
begin
  merker:= TRUE;
  for i:= 1 to 9 do
    if ( ( rote[i] = 0 ) or ( blaue[i] = 0 ) ) then merker:= FALSE;
  alleGesammelt:= merker;
end;

function spielEnde( imSpiel: byte ): boolean;
begin
  endGrund:= 0;
  if imSpiel = 1 then
  begin
    if spieler > 2 then endGrund:= 3 else
    if alleGesammelt then endGrund:= 2;
  end
  else if (imSpiel = 0) then endGrund:= 1;
  spielEnde:= ( endGrund > 0 );
end;

procedure neuZiel(erstes: boolean; nummer: byte);
var
  x, y: byte;
begin
  repeat
    x:= random(78) + 2;
    y:= (random(24) * 2 + 1);
  until ( ((nibbLevl.feld[x, y]) = nibbLevl.leeresFeld)
      and ((nibbLevl.feld[x, (y + 1)]) = nibbLevl.leeresFeld));
  gotoxy(x, (y + 1) div 2);
  textcolor(white);
  if erstes then
  begin
    textbackground(blue);
    nibbLevl.feld[x, y]:= 100 + nummer;
    nibbLevl.feld[x, (y + 1)]:= 100 + nummer;
  end
  else
  begin
    textbackground(red);
    nibbLevl.feld[x, y]:= 110 + nummer;
    nibbLevl.feld[x, (y + 1)]:= 110 + nummer;
  end;
  write(nummer);
end;

procedure initZiel;
var
  i: byte;
begin
  for i:= 1 to 9 do
  begin
    blaue[i]:= 0;
    rote[i]:= 0;
  end;
  bTop:= 1;
  rTop:= 1;
  neuZiel(true, 1);
  neuZiel(false, 1);
end;

function holWachs(nummer, schlangeNr: byte): byte;
var
  wachstum: byte;
begin
  if nummer < 110 then
  begin
    dec(nummer, 100);
    wachstum:= nummer * 2;
    blaue[nummer]:= schlangeNr;
    if ((bTop < 9) and (nummer = bTop)) then
    begin
      inc(bTop);
      neuZiel(true, bTop);
    end;
  end
  else
  begin
    dec(nummer, 110);
    wachstum:= nummer * 3;
    rote[nummer]:= schlangeNr;
    if ((rTop < 9) and (nummer = rTop)) then
    begin
      inc(rTop);
      neuZiel(false, rTop);
    end;
  end;
  holWachs:= wachstum;
end;

procedure gibGesammelte(schlangeNr: byte);
var
  i: byte;
begin
  for i:= 1 to 9 do
  begin
    if blaue[i] = schlangeNr then
    begin
      blaue[i]:= 0;
      neuZiel(true, i);
    end;
    if rote[i] = schlangeNr then
    begin
      rote[i]:= 0;
      neuZiel(false, i);
    end;
  end;
end;

end.